// chmisc.inl
//
// odds and ends
//
// This software was written by Leonard Janke (janke@unixg.ubc.ca)
// in 1996-7 and is entered, by him, into the public domain.

#include <string.h>

inline 
u32 CHMisc::High32Of64(const u64 x)
{
  return x>>32;
}

inline 
u32 CHMisc::Low32Of64(const u64 x)
{
   return x&0xfffffffful;
}

#ifdef __GNUC__
inline
u32 BSwap(u32 x)
{
  asm("bswapl %0\n\t"
      : "=r" (x)
      : "0" (x)
      : "%0"
      );

  return x;
}
#elif defined(__WATCOMC__)
u32 BSwap(u32 x);
#pragma aux BSwap = "bswap eax" parm [eax] value [eax] modify [eax];
#elif defined(_MSC_VER)
inline u32 BSwap(u32 x)
{ 
  __asm mov eax, x 
  __asm bswap eax
  __asm mov x, eax
  return x;
}
#endif

inline 
void CHMisc::MemSwap(u32* buffer, const int dwords)
{
  for (int i=0; i<dwords; i++)
    buffer[i]=BSwap(buffer[i]);
}
